/*
Sprite animés
-------------

ce coup-ci on va garder en mémoire la liste des sprites,
pour pouvoir les piloter

il faut la lib p5play !
http://p5play.molleindustria.org/

Plus d'exemples :
http://p5play.molleindustria.org/examples/index.html
*/

// une variable Array pour stocker les  exemplaires de fantômes
var ghosts = [];

function setup(){ 
	/* exécuté 1 fois au démarrage */

	createCanvas(windowWidth, windowHeight);

	// on ajoute 30 fantômes
	for (var i = 0; i < 30; i++) {
		var g = addGhost(random(0, width), random(0, height));

		// on ajoute le fantôme au stock
		ghosts.push(g);
	};
}
function draw(){
	clear(); // nettoyer l'affichage à chaque cycle

	// on empêche les fantômes de sortir de l'écran
	for (var i = 0; i < ghosts.length; i++) {

		var g = ghosts[i];

		if(g.position.x<0){
			g.velocity.x = Math.abs(g.velocity.x); // vitesse positive
		} else if(g.position.x>width){
			g.velocity.x = -Math.abs(g.velocity.x); // vitesse négative
		}
		if(g.position.y<0){
			g.velocity.y = Math.abs(g.velocity.y); // vitesse positive
		} else if(g.position.y>height){
			g.velocity.y = -Math.abs(g.velocity.y); // vitesse négative
		}
	};

	// !!! imortant !!! rafraichir l'affichage de tous les sprites
	drawSprites();

	// aficher le mode d'emploi !
	text("// Sprites animés avancés", 30, 30);
	// text("Cliquer/toucher pour ajouter un fantôme !", 30, 60);
}

function addGhost(x, y){ // ajoute un fantôme de plus, là où on veut

	// on crée un Sprite, vide
	var ghost = createSprite(x, y, 30, 30); // x, y, L, H

	// cette fois-ci on chosit une anim au hasard
	var num = Math.round(random(0, 2));
	if(num == 0){
		// on lui ajoute 1 animation "floating" (nom arbitraire, puis la série d'images)
		ghost.addAnimation("myanim", "img/ghost_standing0001.png", "img/ghost_standing0007.png");
	} else if(num == 1){
  		ghost.addAnimation("myanim", "img/ghost_spin0001.png", "img/ghost_spin0003.png");
	} else if(num == 2){
  		ghost.addAnimation("myanim", "img/asterisk_circle0001.png", "img/asterisk_circle0008.png");
	}

	// on indique l'anim à jouer
	ghost.changeAnimation("myanim");

	// on peut le retourner (symétrie)
	// ghost.mirrorX(-1);

	// on peut changer sa taille au hasard
	ghost.scale = random(0.25, 1.5);

	// on peut le tourner si on veut
	ghost.rotation = random(-180, 180);

	// si on veut qu'il se déplace, c'est prévu !
	ghost.velocity.x = random(-1, 1);
	ghost.velocity.y = random(-1, 1);

	// la fonction addGhost a fabriqué un fantôme,
	// et elle nous y donne accès si on veut
	return ghost;
}

// pour ajouter des fantômes quand on clique !
function mouseReleased(){
	addGhost(mouseX, mouseY);
}